// GmInput.h
// Game(polytheremin) input management task
// [U͂Ǘ܂.
#include "GmEntry.h"
#include "GmInput.h"

extern Settings *GE_settings;

static char GI_char_to_allegro_key(char aKey){
	switch(aKey){
	case '0':  return KEY_0;
	case '1':  return KEY_1;
	case '2':  return KEY_2;
	case '3':  return KEY_3;
	case '4':  return KEY_4;
	case '5':  return KEY_5;
	case '6':  return KEY_6;
	case '7':  return KEY_7;
	case '8':  return KEY_8;
	case '9':  return KEY_9;

	case 'A':  return KEY_A;
	case 'B':  return KEY_B;
	case 'C':  return KEY_C;
	case 'D':  return KEY_D;
	case 'E':  return KEY_E;
	case 'F':  return KEY_F;
	case 'G':  return KEY_G;
	case 'H':  return KEY_H;
	case 'I':  return KEY_I;
	case 'J':  return KEY_J;
	case 'K':  return KEY_K;
	case 'L':  return KEY_L;
	case 'M':  return KEY_M;
	case 'N':  return KEY_N;
	case 'O':  return KEY_O;
	case 'P':  return KEY_P;
	case 'Q':  return KEY_Q;
	case 'R':  return KEY_R;
	case 'S':  return KEY_S;
	case 'T':  return KEY_T;
	case 'U':  return KEY_U;
	case 'V':  return KEY_V;
	case 'W':  return KEY_W;
	case 'X':  return KEY_X;
	case 'Y':  return KEY_Y;
	case 'Z':  return KEY_Z;
	}
	return KEY_NAN;
}



//public:static 
GmInput *GmInput::createN(){
	GmInput *self = new GmInput();
	if(self->initializeE() != ERROR_NONE){
		delete self;
		self = NULL;
	}
	return self;
}

//public:
GmInput::~GmInput(){
	//AllegroĂ邩svۂ.
	//remove_joystick();
}

//public:
int GmInput::setListener(KeyListener *aKeyListener){
/*	if(iKeyListener){
		return ERROR_GENERAL;
	}*/
	iKeyListener = aKeyListener;
	for(int j = 0; j < GI_KEY_NUM; j++){
		iBindedKeyStatus[j] = 0;
	}
	return ERROR_NONE;
}

//public:
int GmInput::releaseListener(KeyListener *aKeyListener){
	if(iKeyListener != aKeyListener){
		return ERROR_GENERAL;
	}
	iKeyListener = NULL;
	return ERROR_NONE;
}


//public:
void GmInput::update(){
	//update member functions.
	int i, j;

	//mouse&keyboardXV(ōXVȂ炵Ĥpoll modeɂĂ).
	poll_keyboard();
	//L[{[hԍXV.
	for(i = 0; i < iBindedKeyNum; i++){

		//L[ԂAllegro擾čXV.
		int prevKeyStatus = iBindedKeyStatus[i];
		iBindedKeyStatus[i] = 0;
		for(j = 0; j < GI_KEY_ARRAY_NUM; j++){
			if(iBindedKey[j][i] != KEY_NAN){
				iBindedKeyStatus[i] |= key[iBindedKey[j][i]];
			}
		}

		
		//0Ԃ̃L[R[hŃXiɒʒm.
		if(iKeyListener){
			if((prevKeyStatus) & !(iBindedKeyStatus[i])){
				//Ƃ.
				iKeyListener->keyReleased(iBindedKey[0][i]);
				//L[OۑƂ?TBD.
			}else if(!(prevKeyStatus) & (iBindedKeyStatus[i])){
				//Ƃ.
				iKeyListener->keyPressed(iBindedKey[0][i]);
				//L[OۑƂ?TBD.
			}
		}
	}//next i

	//}EXԍXV.
	poll_mouse();
	iMouseX = mouse_x;
	iMouseY = mouse_y;
	//قƂmouse_bBindedKeŷЂƂƂĊǗق.KEY_MOUSE_L ƂĂ.
	iMouseBtn = mouse_b;

	//FPSnȂ}EXW𒆉ɃZbg
	//position_mouse((GmMain::getCurrentGmMain()->getGmGfxN()->getScreenW())>>1, (GmMain::getCurrentGmMain()->getGmGfxN()->getScreenH())>>1);
}

//private:
GmInput::GmInput():
iMouseX(0),
iMouseY(0),
iMouseBtn(0),
iBindedKeyNum(0),
iKeyListener(NULL) {
	//܂KEY_NANŃNA.
	for(int i = 0; i < GI_KEY_ARRAY_NUM; i++){
		for(int j = 0; j < GI_KEY_NUM; j++){
			iBindedKey[i][j] = KEY_NAN;
			iBindedKeyStatus[j] = 0;//iJԂ̂͂ƃ_ǂ.
		}
	}
}

//private:
int GmInput::initializeE(){
	int i = 0;
	//ftHgL[`.ێĝ͂܂̂Ƃ7ނɂĂ݂.
	iBindedKeyNum = 7;
	i = 0;
	iBindedKey[i][0] = KEY_UP;
	iBindedKey[i][1] = KEY_DOWN;
	iBindedKey[i][2] = KEY_LEFT;
	iBindedKey[i][3] = KEY_RIGHT;
	iBindedKey[i][4] = KEY_Z;
	iBindedKey[i][5] = KEY_X;
	iBindedKey[i][6] = KEY_C;

	i = 1;
	iBindedKey[i][0] = KEY_8_PAD;
	iBindedKey[i][1] = KEY_2_PAD;
	iBindedKey[i][2] = KEY_4_PAD;
	iBindedKey[i][3] = KEY_6_PAD;
	iBindedKey[i][4] = KEY_SPACE;
	iBindedKey[i][5] = KEY_NAN;
	iBindedKey[i][6] = KEY_NAN;
	
	i = 2;
	//[U`L[oCh
	for(int j = 0; iBindedKeyNum < GI_KEY_NUM; j++){
		iBindedKey[i][j] = GI_char_to_allegro_key(GE_settings->bindedKey[j]);
		if(iBindedKey[i][j] == KEY_NAN){
			break;
		}
	}

	i = 3;
	//joypadȂǂȂ.TBD.
//	if(install_joystick(JOY_TYPE_AUTODETECT) == 0){
//	}

	return ERROR_NONE;
}

#if 0
	int iMouseX;
	int iMouseY;

	//gL[̐.
	int iBindedKeyNum;
	//gL[̃R[h.
	int iBindedKey[256];
	//gL[̏(indexiBinedKeyƓ).
	int iBindedKeyStatus[256];
#endif